

-- Generated by Relational Schema Center on Wed Apr 26 18:03:47 EDT 2006 for Oracle9i

-- -------------------------------------------------
-- Drop the IBM IMS MDS Server Database tables.
-- Drop tables that references foreign keys first.
-- -------------------------------------------------

DROP SEQUENCE ASSIGNMENT_SEQ;
DROP TABLE SMSOBJECTDATA;
DROP TABLE SMSNOTIFICATIONDATA;
DROP TABLE SMSRECEIVEDATA;
DROP TABLE SMSSENDDATA;

-- - Drop Tables.ddl end ---------------------------
   

CREATE TABLE SMSSENDDATA
  (TRANSACTIONID VARCHAR2(250) NOT NULL,
   SEGMENTNUMBER INTEGER NOT NULL,
   CREATETIME TIMESTAMP(6) NOT NULL,
   EXPIRETIME TIMESTAMP(6) NULL,
   DELIVERYTIME TIMESTAMP(6) NULL,
   ASSIGNMENTID INTEGER NULL,
   CHARGING VARCHAR2(250) NULL,
   MESSAGELENGTH INTEGER NOT NULL,
   DESTINATION VARCHAR2(250) NOT NULL,
   REQUESTER VARCHAR2(250) NOT NULL,
   SERVICE VARCHAR2(250) NOT NULL,
   CORRELATOR VARCHAR2(250) NULL,
   DELIVERYSTATUS INTEGER NOT NULL,
   ATTRIBUTES VARCHAR2(250) NULL,
   NETWORKID VARCHAR2(250) NULL,
   ELEMENTID VARCHAR2(250) NULL);

ALTER TABLE SMSSENDDATA
  ADD CONSTRAINT PK_SMSSENDDATA PRIMARY KEY (TRANSACTIONID, SEGMENTNUMBER, DESTINATION);

CREATE TABLE SMSRECEIVEDATA
  (MESSAGEID NUMBER(38, 0) NOT NULL,
   CREATETIME TIMESTAMP(6) NOT NULL,
   EXPIRETIME TIMESTAMP(6) NULL,
   NOTIFICATIONTRANSID VARCHAR2(250) NOT NULL,
   MESSAGE VARCHAR2(1000) NOT NULL,
   ATTRIBUTES VARCHAR2(1000) NULL,
   SENDER VARCHAR2(250) NULL,
   DESTINATION VARCHAR2(250) NULL,
   CORRELATOR VARCHAR2(250) NULL,
   SERVICE VARCHAR2(250) NULL,
   REQUESTER VARCHAR2(250) NULL);

ALTER TABLE SMSRECEIVEDATA
  ADD CONSTRAINT PK_SMSRECEIVEDATA PRIMARY KEY (MESSAGEID, NOTIFICATIONTRANSID);

CREATE TABLE SMSNOTIFICATIONDATA
  (TRANSACTIONID VARCHAR2(250) NOT NULL,
   CREATETIME TIMESTAMP(6) NOT NULL,
   EXPIRETIME TIMESTAMP(6) NULL,
   DESTINATION VARCHAR2(250) NULL,
   CRITERIA VARCHAR2(250) NULL,
   ENDPOINT VARCHAR2(250) NOT NULL,
   REQUESTER VARCHAR2(250) NOT NULL,
   SERVICE VARCHAR2(250) NOT NULL,
   CORRELATOR VARCHAR2(250) NOT NULL,
   ELEMENTID VARCHAR2(250) NULL,
   ASSIGNMENTID INTEGER NULL,
   ATTRIBUTES VARCHAR2(1000) NULL);

ALTER TABLE SMSNOTIFICATIONDATA
  ADD CONSTRAINT PK_SMSNOTIFICATIONDATA PRIMARY KEY (TRANSACTIONID);

CREATE TABLE SMSOBJECTDATA
  (ELEMENTID VARCHAR2(250) NOT NULL,
   ASSIGNMENTID INTEGER NOT NULL,
   SAVEDOBJECT BLOB NOT NULL,
   CREATETIME DATE NULL,
   EXPIRETIME DATE NULL);

ALTER TABLE SMSOBJECTDATA
  ADD CONSTRAINT PK_SMSOBJECTDATA PRIMARY KEY (ELEMENTID, ASSIGNMENTID);


-- Add additional indexes
-- -------------------------------------------------------------------
-- DCR56
   CREATE INDEX I_SMSNOTIF_TCRS      ON SMSNOTIFICATIONDATA (TRANSACTIONID ASC,CORRELATOR ASC,REQUESTER ASC,SERVICE ASC); 
   CREATE INDEX I_SMSNOTIF_CS        ON SMSNOTIFICATIONDATA (CORRELATOR ASC, SERVICE ASC); 
   CREATE INDEX I_SMSNOTIF_D	     ON SMSNOTIFICATIONDATA (DESTINATION ASC); 
   CREATE INDEX I_SMSNOTIF_CSR	     ON SMSNOTIFICATIONDATA (CORRELATOR ASC,SERVICE ASC,REQUESTER ASC); 
   CREATE INDEX I_SMSNOTIF_EA	     ON SMSNOTIFICATIONDATA (ELEMENTID ASC,ASSIGNMENTID ASC); 
   CREATE INDEX I_SMSNOTIF_EX	     ON SMSNOTIFICATIONDATA (EXPIRETIME ASC); 
-- DCR56
   CREATE INDEX I_SMSOBJ_AC        ON SMSOBJECTDATA       (ASSIGNMENTID ASC, CREATETIME DESC) ;
   CREATE INDEX I_SMSOBJ_CE        ON SMSOBJECTDATA       (CREATETIME ASC, EXPIRETIME DESC) ;
   CREATE INDEX I_SMSSEND_AED      ON SMSSENDDATA         (ASSIGNMENTID ASC, ELEMENTID ASC, DESTINATION ASC) ;
   CREATE INDEX I_SMSSEND_AES      ON SMSSENDDATA         (ASSIGNMENTID ASC, ELEMENTID ASC, DELIVERYSTATUS ASC) ;
   CREATE INDEX I_SMSSEND_AEDS     ON SMSSENDDATA         (ASSIGNMENTID ASC, ELEMENTID ASC, DESTINATION ASC, DELIVERYSTATUS ASC);
   CREATE INDEX I_SMSSEND_TDS      ON SMSSENDDATA         (TRANSACTIONID ASC, DESTINATION ASC, DELIVERYSTATUS ASC);
   CREATE INDEX I_SMSSEND_TSDAM    ON SMSSENDDATA         (TRANSACTIONID ASC, SEGMENTNUMBER ASC, DESTINATION ASC, ASSIGNMENTID ASC, MESSAGELENGTH ASC) ;

   CREATE INDEX I_SMSSEND_ENA	   ON SMSSENDDATA         (ELEMENTID ASC, NETWORKID ASC,  ASSIGNMENTID ASC) ;
   CREATE INDEX I_SMSSEND_ND	   ON SMSSENDDATA         (NETWORKID ASC,  DESTINATION ASC) ;
   CREATE INDEX I_SMSSEND_ENADL	   ON SMSSENDDATA         (ELEMENTID ASC, NETWORKID ASC, ASSIGNMENTID ASC, DELIVERYSTATUS ASC) ;
   CREATE INDEX I_SMSSEND_N	   ON SMSSENDDATA         (NETWORKID ASC) ;
   CREATE INDEX I_SMSSEND_ENADE	   ON SMSSENDDATA         (ELEMENTID ASC, NETWORKID ASC, ASSIGNMENTID ASC, DESTINATION ASC) ;
   CREATE INDEX I_SMSSEND_DN	   ON SMSSENDDATA         (DESTINATION ASC, NETWORKID ASC) ;
   CREATE INDEX I_SMSSEND_EAD      ON SMSSENDDATA         (ELEMENTID ASC, ASSIGNMENTID ASC, DESTINATION ASC) ;
   CREATE INDEX I_SMSSEND_TD       ON SMSSENDDATA         (TRANSACTIONID ASC, DESTINATION ASC) ;
   CREATE INDEX I_SMSSEND_TSDD    ON SMSSENDDATA         (TRANSACTIONID ASC, SEGMENTNUMBER ASC, DESTINATION ASC, DELIVERYSTATUS ASC) ;
   CREATE INDEX I_SMSSEND_E        ON SMSSENDDATA         (EXPIRETIME ASC) ;
   CREATE INDEX I_SMSSEND_EDL      ON SMSSENDDATA         (EXPIRETIME ASC,DELIVERYSTATUS ASC) ;

-- The following is not generated..will be lost if this file is regenerated
CREATE SEQUENCE ASSIGNMENT_SEQ MINVALUE 1 START WITH 1 INCREMENT BY 1 CACHE 20;

COMMIT;

QUIT;

