DROP SEQUENCE ASSIGNMENT_SEQ;
DROP TABLE WAPPUSHSENDDATA;
DROP TABLE WAPPUSHNOTIFICATIONDATA;


CREATE TABLE WAPPUSHSENDDATA
  (TRANSACTIONID VARCHAR(250) NOT NULL,
   SEGMENTNUMBER INTEGER NOT NULL,
   CREATETIME TIMESTAMP NOT NULL,
   EXPIRETIME TIMESTAMP,
   DELIVERYTIME TIMESTAMP,
   ASSIGNMENTID INTEGER,
   CHARGING VARCHAR(250),
   MESSAGELENGTH INTEGER NOT NULL,
   DESTINATION VARCHAR(250) NOT NULL,
   REQUESTER VARCHAR(250) NOT NULL,
   SERVICE VARCHAR(250) NOT NULL,
   CORRELATOR VARCHAR(250),
   DELIVERYSTATUS INTEGER NOT NULL,
   ATTRIBUTES VARCHAR(250),
   NETWORKID VARCHAR(250),
   ELEMENTID VARCHAR(250));

ALTER TABLE WAPPUSHSENDDATA
  ADD CONSTRAINT PK_WAPPUSHSENDDATA PRIMARY KEY (TRANSACTIONID, SEGMENTNUMBER, DESTINATION);


CREATE TABLE WAPPUSHNOTIFICATIONDATA
  (TRANSACTIONID VARCHAR(250) NOT NULL,
   CREATETIME TIMESTAMP NOT NULL,
   EXPIRETIME TIMESTAMP,   
   ENDPOINT VARCHAR(250) NOT NULL,
   REQUESTER VARCHAR(250) NOT NULL,
   SERVICE VARCHAR(250) NOT NULL,
   CORRELATOR VARCHAR(250) NOT NULL,
   ELEMENTID VARCHAR(250),
   ASSIGNMENTID INTEGER,
   ATTRIBUTES VARCHAR(250));

ALTER TABLE WAPPUSHNOTIFICATIONDATA
  ADD CONSTRAINT PK_WAPPUSHNOTIFICA PRIMARY KEY (TRANSACTIONID);

-- Add additional indexes WAPPUSHSENDDATA

  CREATE INDEX I_WAPPUSHSEND_T		ON WAPPUSHSENDDATA         (TRANSACTIONID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_ETDS	ON WAPPUSHSENDDATA         (EXPIRETIME ASC, DELIVERYSTATUS ASC ) ;
  CREATE INDEX I_WAPPUSHSEND_TDD	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, DESTINATION ASC, DELIVERYSTATUS ASC ) ;
  CREATE INDEX I_WAPPUSHSEND_TSDS	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, SEGMENTNUMBER ASC, DELIVERYSTATUS ASC ) ;
  CREATE INDEX I_WAPPUSHSEND_ENAD	ON WAPPUSHSENDDATA         (ELEMENTID ASC, NETWORKID ASC, ASSIGNMENTID ASC, DESTINATION ASC) ;
  CREATE INDEX I_WAPPUSHSEND_TDDD	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, DESTINATION ASC, DELIVERYSTATUS DESC ) ;
  CREATE INDEX I_WAPPUSHSEND_EIA	ON WAPPUSHSENDDATA         (ELEMENTID ASC, ASSIGNMENTID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_ND		ON WAPPUSHSENDDATA         (NETWORKID ASC, DESTINATION ASC) ;
  CREATE INDEX I_WAPPUSHSEND_ET		ON WAPPUSHSENDDATA         (EXPIRETIME ASC) ;
  CREATE INDEX I_WAPPUSHSEND_DN		ON WAPPUSHSENDDATA         (DESTINATION ASC, NETWORKID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_EINA	ON WAPPUSHSENDDATA         (ELEMENTID ASC, NETWORKID ASC, ASSIGNMENTID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_N		ON WAPPUSHSENDDATA         (NETWORKID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_TSDD	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, SEGMENTNUMBER ASC, DESTINATION ASC, DELIVERYSTATUS ASC ) ;
--

-- Add additional indexes WAPPUSHNOTIFICATIONDATA

  CREATE INDEX I_WAPPUSHNF_CS	   ON WAPPUSHNOTIFICATIONDATA         (CORRELATOR ASC, SERVICE ASC) ;
  CREATE INDEX I_WAPPUSHNF_CSR	   ON WAPPUSHNOTIFICATIONDATA         (CORRELATOR ASC, SERVICE ASC, REQUESTER ASC) ;
  CREATE INDEX I_WAPPUSHNF_EIA	   ON WAPPUSHNOTIFICATIONDATA         (ELEMENTID ASC, ASSIGNMENTID ASC) ;
  CREATE INDEX I_WAPPUSHNF_ET	   ON WAPPUSHNOTIFICATIONDATA         (EXPIRETIME ASC) ;
--


CREATE SEQUENCE ASSIGNMENT_SEQ AS INTEGER START WITH 1000 INCREMENT BY 1 CYCLE;


QUIT;
