DROP SEQUENCE ASSIGNMENT_SEQ;
DROP TABLE WAPPUSHSENDDATA;
DROP TABLE WAPPUSHNOTIFICATIONDATA;


CREATE TABLE WAPPUSHSENDDATA
  (TRANSACTIONID VARCHAR2(250) NOT NULL,
   SEGMENTNUMBER NUMBER(10) NOT NULL,
   CREATETIME TIMESTAMP NOT NULL,
   EXPIRETIME TIMESTAMP,
   DELIVERYTIME TIMESTAMP,
   ASSIGNMENTID NUMBER(10),
   CHARGING VARCHAR2(250),
   MESSAGELENGTH NUMBER(10) NOT NULL,
   DESTINATION VARCHAR2(250) NOT NULL,
   REQUESTER VARCHAR2(250) NOT NULL,
   SERVICE VARCHAR2(250) NOT NULL,
   CORRELATOR VARCHAR2(250),
   DELIVERYSTATUS NUMBER(10) NOT NULL,
   ATTRIBUTES VARCHAR2(250),
   NETWORKID VARCHAR2(250),
   ELEMENTID VARCHAR2(250));

ALTER TABLE WAPPUSHSENDDATA
  ADD CONSTRAINT PK_WAPPUSHSENDDATA PRIMARY KEY (TRANSACTIONID, SEGMENTNUMBER, DESTINATION);


CREATE TABLE WAPPUSHNOTIFICATIONDATA
  (TRANSACTIONID VARCHAR2(250) NOT NULL,
   CREATETIME TIMESTAMP NOT NULL,
   EXPIRETIME TIMESTAMP,   
   ENDPOINT VARCHAR2(250) NOT NULL,
   REQUESTER VARCHAR2(250) NOT NULL,
   SERVICE VARCHAR2(250) NOT NULL,
   CORRELATOR VARCHAR2(250) NOT NULL,
   ELEMENTID VARCHAR2(250),
   ASSIGNMENTID NUMBER(10),
   ATTRIBUTES VARCHAR2(250));

ALTER TABLE WAPPUSHNOTIFICATIONDATA
  ADD CONSTRAINT PK_WAPPUSHNOTIFICA PRIMARY KEY (TRANSACTIONID);

-- Add additional indexes WAPPUSHSENDDATA

  CREATE INDEX I_WAPPUSHSEND_T		ON WAPPUSHSENDDATA         (TRANSACTIONID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_ETDS	ON WAPPUSHSENDDATA         (EXPIRETIME ASC, DELIVERYSTATUS ASC ) ;
  CREATE INDEX I_WAPPUSHSEND_TDD	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, DESTINATION ASC, DELIVERYSTATUS ASC ) ;
  CREATE INDEX I_WAPPUSHSEND_TSDS	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, SEGMENTNUMBER ASC, DELIVERYSTATUS ASC ) ;
  CREATE INDEX I_WAPPUSHSEND_ENAD	ON WAPPUSHSENDDATA         (ELEMENTID ASC, NETWORKID ASC, ASSIGNMENTID ASC, DESTINATION ASC) ;
  CREATE INDEX I_WAPPUSHSEND_TDDD	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, DESTINATION ASC, DELIVERYSTATUS DESC ) ;
  CREATE INDEX I_WAPPUSHSEND_EIA	ON WAPPUSHSENDDATA         (ELEMENTID ASC, ASSIGNMENTID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_ND		ON WAPPUSHSENDDATA         (NETWORKID ASC, DESTINATION ASC) ;
  CREATE INDEX I_WAPPUSHSEND_ET		ON WAPPUSHSENDDATA         (EXPIRETIME ASC) ;
  CREATE INDEX I_WAPPUSHSEND_DN		ON WAPPUSHSENDDATA         (DESTINATION ASC, NETWORKID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_EINA	ON WAPPUSHSENDDATA         (ELEMENTID ASC, NETWORKID ASC, ASSIGNMENTID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_N		ON WAPPUSHSENDDATA         (NETWORKID ASC) ;
  CREATE INDEX I_WAPPUSHSEND_TSDD	ON WAPPUSHSENDDATA         (TRANSACTIONID ASC, SEGMENTNUMBER ASC, DESTINATION ASC, DELIVERYSTATUS ASC ) ;
--

-- Add additional indexes WAPPUSHNOTIFICATIONDATA

CREATE INDEX I_WAPPUSHNF_CS	   ON WAPPUSHNOTIFICATIONDATA         (CORRELATOR ASC, SERVICE ASC) ;
CREATE INDEX I_WAPPUSHNF_CSR	   ON WAPPUSHNOTIFICATIONDATA         (CORRELATOR ASC, SERVICE ASC, REQUESTER ASC) ;
CREATE INDEX I_WAPPUSHNF_EIA	   ON WAPPUSHNOTIFICATIONDATA         (ELEMENTID ASC, ASSIGNMENTID ASC) ;
CREATE INDEX I_WAPPUSHNF_ET	   ON WAPPUSHNOTIFICATIONDATA         (EXPIRETIME ASC) ;
--


CREATE SEQUENCE ASSIGNMENT_SEQ MINVALUE 1000 START WITH 1000 INCREMENT BY 1 NOCACHE;


QUIT;
