#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2000, 2006
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import sys.argv
import getopt
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue

from pytwss.mbean import spm_mbean, mbean_utils
from pytwss.utils import _, log

MI_SERVICE = 'http://www.csapi.org/wsdl/parlayx/group_mgmt/v2_1/interface'
GR_SERVICE = 'http://www.csapi.org/wsdl/parlayx/group/v2_1/interface'
GM_SERVICE = 'http://www.csapi.org/wsdl/parlayx/group_member/v2_1/interface'
SVC_GROUP = 'Address List Management'
SERVICE_IMPL = 'PX21_GRP_IMS'
MI_IMPL = 'PX21_GRP_IMS_MI'
GR_IMPL = 'PX21_GRP_IMS_GR'
GM_IMPL = 'PX21_GRP_IMS_GM'

def main(**kwargs):
	req_scope = 'ALL'
	if kwargs.has_key('req_scope'):
		req_scope = kwargs['req_scope']
	svc_scope = SVC_GROUP
	if kwargs.has_key('svc_scope'):
		svc_scope = kwargs['svc_scope']
	op_scope = 'ALL'
	if kwargs.has_key('op_scope'):
		op_scope = kwargs['op_scope']

	log(_("SOAC7520I") %{ 'impl' : SERVICE_IMPL })

	svc_admin = spm_mbean.ServiceAdministration()
	policy_admin = spm_mbean.PolicyAdministration()

	spm_mbean.registerServiceImplementation(
		svc_admin, MI_SERVICE, MI_IMPL, 1,
		'Parlay X 2.1 Address List Management Group Management IMS Service')
	spm_mbean.registerServiceImplementation(
		svc_admin, GR_SERVICE, GR_IMPL, 1,
		'Parlay X 2.1 Address List Management Group IMS Service')
	spm_mbean.registerServiceImplementation(
		svc_admin, GM_SERVICE, GM_IMPL, 1,
		'Parlay X 2.1 Address List Management Group Member IMS Service')

	policies = [
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.auth.Password',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='Password'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.Endpoint',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='String'
		#	)
		#),
	]
	#spm_mbean.createPolicies(policy_admin, policies)
	log(_("SOAC7521I") %{ 'impl' : SERVICE_IMPL })

def parseOpts(args):
	opts = { }
	try:
		pairs, args = getopt.getopt(args, '', [
			'req_scope=', # Explicit requester scope
			'svc_scope=', # Explicit service scope
			'op_scope=',  # Explicit operation scope
		])
		for opt, val in pairs:
			if opt[:2] == '--':
				opt = opt[2:]
			opts[opt] = val
	except getopt.GetoptError:
		pass
	return opts

# Execute if we're the main script
if __name__ == 'main':
	opts = parseOpts(sys.argv)
	if opts:
		log(_("SOAC7522I"))
		for key in opts.keys():
			log(_("SOAC7523I") %{ 'opt' : key, 'arg' : opts[key] })
	main(**opts)
