#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2000, 2006
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import sys.argv
import getopt
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue

from pytwss.mbean import spm_mbean, mbean_utils
from pytwss.utils import _, log

NMI_SERVICE = 'http://www.csapi.org/wsdl/parlayx/terminal_status/notification_manager/v2_2/interface'
NI_SERVICE = 'http://www.csapi.org/wsdl/parlayx/terminal_status/notification/v2_2/interface'
TS_SERVICE = 'http://www.csapi.org/wsdl/parlayx/terminal_status/v2_2/interface'
SVC_GROUP = 'Terminal Status'
SERVICE_IMPL = 'PX21_TS_IMS'
NMI_IMPL = 'PX21_TS_IMS_NMI'
NI_IMPL = 'PX21_TS_IMS_NI'
TS_IMPL = 'PX21_TS_IMS_TS'

def main(**kwargs):
	req_scope = 'ALL'
	if kwargs.has_key('req_scope'):
		req_scope = kwargs['req_scope']
	svc_scope = SVC_GROUP
	if kwargs.has_key('svc_scope'):
		svc_scope = kwargs['svc_scope']
	op_scope = 'ALL'
	if kwargs.has_key('op_scope'):
		op_scope = kwargs['op_scope']

	log(_("SOAC7520I") %{ 'impl' : SERVICE_IMPL })

	svc_admin = spm_mbean.ServiceAdministration()
	policy_admin = spm_mbean.PolicyAdministration()

	spm_mbean.registerServiceImplementation(
		svc_admin, TS_SERVICE, TS_IMPL, 1,
		'Parlay X 2.1 Terminal Status IMS Service')
	spm_mbean.registerServiceImplementation(
		svc_admin, NI_SERVICE, NI_IMPL, 1,
		'Parlay X 2.1 Terminal Status Notification IMS Service')
	spm_mbean.registerServiceImplementation(
		svc_admin, NMI_SERVICE, NMI_IMPL, 1,
		'Parlay X 2.1 Terminal Status Notification Management IMS Service')

	policies = [
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.ServiceImplementationName',
			value=PolicyValue(
				value='PX21_TS_IMS',
				type='String'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.service.config.presence.TerminalBusyRpidActivities',
			value=PolicyValue(
				value='on-the-phone',
				type='String'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.service.config.presence.PresenceFetchTimeoutInMillis',
			value=PolicyValue(
				value='1000',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.BusyAvailable',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.MaximumNotificationAddresses',
			value=PolicyValue(
				value='2147483647', # Java Integer.MAX_INTEGER
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.MaximumNotificationFrequency',
			value=PolicyValue(
				value='1',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.MaximumNotificationDuration',
			value=PolicyValue(
				value='9223372036854775807', # Java Integer.MAX_LONG
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.DefaultNotificationDuration',
			value=PolicyValue(
				value='86400000', # 24 hours
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.MaximumCount',
			value=PolicyValue(
				value='2147483647', # Java Integer.MAX_INTEGER
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.UnlimitedCountAllowed',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.ims.InterOperatorIdentifier',
		#	value=PolicyValue(
		#		value='', # No-op value for IOI
		#		type='String'
		#	)
		#),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.AdditionalGroupURISchemes',
			value=PolicyValue(
				value='glmgroup',
				type='String'
			)
		),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.presence.PresenceServerSIPURI',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='String'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.presence.PresenceServerResourceName',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='String'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.Endpoint',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='String'
		#	)
		#),
	]
	spm_mbean.createPolicies(policy_admin, policies)
	log(_("SOAC7521I") %{ 'impl' : SERVICE_IMPL })

def parseOpts(args):
	opts = { }
	try:
		pairs, args = getopt.getopt(args, '', [
			'req_scope=', # Explicit requester scope
			'svc_scope=', # Explicit service scope
			'op_scope=',  # Explicit operation scope
		])
		for opt, val in pairs:
			if opt[:2] == '--':
				opt = opt[2:]
			opts[opt] = val
	except getopt.GetoptError:
		pass
	return opts

# Execute if we're the main script
if __name__ == 'main':
	opts = parseOpts(sys.argv)
	if opts:
		log(_("SOAC7522I"))
		for key in opts.keys():
			log(_("SOAC7523I") %{ 'opt' : key, 'arg' : opts[key] })
	main(**opts)
