#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2000, 2006
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import sys.argv
import getopt
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue

from pytwss.mbean import spm_mbean, mbean_utils
from pytwss.utils import _, log

NM_SERVICE = 'http://www.csapi.org/wsdl/parlayx/terminal_status/notification_manager/v2_2/interface'
NI_SERVICE = 'http://www.csapi.org/wsdl/parlayx/terminal_status/notification/v2_2/interface'
TS_SERVICE = 'http://www.csapi.org/wsdl/parlayx/terminal_status/v2_2/interface'
SVC_GROUP = 'Terminal Status'
SERVICE_IMPL = 'PX21_TS_Parlay'
NM_IMPL = 'PX21_TS_Parlay_NM'
NI_IMPL = 'PX21_TS_Parlay_NI'
TS_IMPL = 'PX21_TS_Parlay_TS'

def main(**kwargs):
	req_scope = 'ALL'
	if kwargs.has_key('req_scope'):
		req_scope = kwargs['req_scope']
	svc_scope = SVC_GROUP
	if kwargs.has_key('svc_scope'):
		svc_scope = kwargs['svc_scope']
	op_scope = 'ALL'
	if kwargs.has_key('op_scope'):
		op_scope = kwargs['op_scope']

	log(_("SOAC7520I") %{ 'impl' : SERVICE_IMPL })

	svc_admin = spm_mbean.ServiceAdministration()
	policy_admin = spm_mbean.PolicyAdministration()
	type_admin = spm_mbean.TypeAdministration()

	spm_mbean.registerServiceImplementation(
		svc_admin, NM_SERVICE, NM_IMPL, 1,
		'Parlay X 2.1 Terminal Status Notification Management Parlay Service')
	spm_mbean.registerServiceImplementation(
		svc_admin, NI_SERVICE, NI_IMPL, 1,
		'Parlay X 2.1 Terminal Status Notification Parlay Service')
	spm_mbean.registerServiceImplementation(
		svc_admin, TS_SERVICE, TS_IMPL, 1,
		'Parlay X 2.1 Terminal Status Parlay Service')

	# Policies common to the general service scope
	common_policies = [
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.pacing.WaitPeriod',
			value=PolicyValue(
				value='5',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.CallLevelPrivacy',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.ProcessUpToLimit',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.transaction.monitoring.StateTransitionAlarmPeriod',
			value=PolicyValue(
				value='30',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.transaction.monitoring.StateTransitionWarningPeriod',
			value=PolicyValue(
				value='30',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.config.pacing.PacingEnabled',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.target.Ranges',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='SemiColonStringList'
		#	)
		#),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.config.target.Aliases',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='SemiColonStringList'
		#	)
		#),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.StatusMaximumAddresses',
			value=PolicyValue(
				value='50',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.StatusBusyAvailable',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.StatusGroupSupport',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='service.standard.StatusNestedGroupSupport',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		#ScopedPolicy(
		#	requesterIdentifier=req_scope,
		#	serviceIdentifier=svc_scope,
		#	operation=op_scope,
		#	name='service.Endpoint',
		#	value=PolicyValue(
		#		value='<someval>',
		#		type='String'
		#	)
		#),
	]
	spm_mbean.createPolicies(policy_admin, common_policies)

	# Get status specific policies
	status_policies = [
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=TS_SERVICE,
			operation='getStatus',
			name='service.standard.StatusResponseTime',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
	]
	spm_mbean.createPolicies(policy_admin, status_policies)

	# Notification management policies
	notify_policies = [
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=NM_SERVICE,
			operation='ALL',
			name='service.standard.StatusMaximumNotificationDuration',
			value=PolicyValue(
				value='3600000', # 1 hour
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=NM_SERVICE,
			operation='ALL',
			name='service.standard.StatusMaximumNotificationFrequency',
			value=PolicyValue(
				value='60000', # 1 minute
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=NM_SERVICE,
			operation='ALL',
			name='service.standard.StatusUnlimitedCountAllowed',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=NM_SERVICE,
			operation=op_scope,
			name='service.standard.MaximumNotificationAddresses',
			value=PolicyValue(
				value='5',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=NM_SERVICE,
			operation='ALL',
			name='service.standard.StatusMaximumCount',
			value=PolicyValue(
				value='10',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=NM_SERVICE,
			operation='ALL',
			name='service.standard.StatusNotificationAvailable',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
	]
	spm_mbean.createPolicies(policy_admin, notify_policies)

	log(_("SOAC7521I") %{ 'impl' : SERVICE_IMPL })

def parseOpts(args):
	opts = { }
	try:
		pairs, args = getopt.getopt(args, '', [
			'req_scope=', # Explicit requester scope
			'svc_scope=', # Explicit service scope
			'op_scope=',  # Explicit operation scope
		])
		for opt, val in pairs:
			if opt[:2] == '--':
				opt = opt[2:]
			opts[opt] = val
	except getopt.GetoptError:
		pass
	return opts

# Execute if we're the main script
if __name__ == 'main':
	opts = parseOpts(sys.argv)
	if opts:
		log(_("SOAC7522I"))
		for key in opts.keys():
			log(_("SOAC7523I") %{ 'opt' : key, 'arg' : opts[key] })
	main(**opts)
